<template>
  <b-container fluid>
    <b-card :header="caption">
      <div slot="header">
        Заявки
        <div class="card-header-actions">
          <button :disabled="isDisabled()" class="btn btn-primary btn-sm" @click="openAddingModal">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <b-form inline>
        <label>Выберите даты, от:</label>
        <datepicker
          @input="selected.text = ''"
          :language="ru"
          v-model="paginationOptions.dateFrom"
          class="mb-2 mr-sm-2 mb-sm-0"
        ></datepicker>
        <label>До:</label>
        <datepicker
          @input="selected.text = ''"
          :language="ru"
          v-model="paginationOptions.dateTo"
          class="mb-2 mr-sm-2 mb-sm-0"
        ></datepicker>
        <b-button variant="primary" @click.prevent="getBids();">Применить</b-button>
      </b-form>
      <br>

      <b-form inline>
        <b-form-input
          class="mb-2 mr-sm-2 mb-sm-0 col-sm-4"
          v-model="selected.text"
          placeholder="Поиск..."
        ></b-form-input>
        <b-form-select class="mb-2 mr-sm-2 mb-sm-0" v-model="selected.type" :options="types"></b-form-select>
        <b-button variant="primary" class="mb-2 mr-sm-2 mb-sm-0" @click.prevent="getBids()">Показать</b-button>
      </b-form>
      <br>

      <b-table
        :hover="hover"
        :bordered="bordered"
        :small="small"
        responsive
        :items="items"
        :fields="fields"
        :current-page="paginationOptions.page"
      >
        <template slot="number" slot-scope="data">{{(data.item.number).padStart(5, '0')}}</template>
        <template slot="provider" slot-scope="data">
          <div v-for="pro in data.item.provider">
            <div
              v-if="pro.id"
            >{{pro.id.name + ' ' + pro.id.lastName + ', ' + pro.placeAmount + ', ' + pro.summ + '\n'}}</div>
          </div>
        </template>
        <template slot="date" slot-scope="data">
          <div v-if="data.item.date">{{ dateFormat(data.item.date) }}</div>
        </template>
        <template slot="contrAgent" slot-scope="data">
          <div
            v-if="data.item.contrAgent"
          >{{data.item.contrAgent.lastName + ' ' + data.item.contrAgent.name}}</div>
        </template>
        <template slot="city" slot-scope="data">
          <div v-if="data.item.contrAgent">{{data.item.contrAgent.city}}</div>
        </template>
        <template
          slot="payStatus"
          slot-scope="data"
        >{{data.item.payStatus === 'online' ? "Онлайн" : data.item.payStatus === 'cash' ? "Наличными" : data.item.payStatus === 'payed' ? "Оплачено" : "Нет данных"}}</template>
        <template slot="status" slot-scope="data">
          <div v-if="data.item.status === 'storage'">
            <b-badge variant="danger">На складе</b-badge>
          </div>
          <div v-else-if="data.item.status === 'ship'">
            <b-badge variant="warning">В дороге</b-badge>
          </div>
          <div v-else-if="data.item.status === 'done'">
            <b-badge variant="success">Доставлено</b-badge>
          </div>
          <div v-else-if="data.item.status === 'end'">
            <b-badge variant="success">Завершен</b-badge>
          </div>
        </template>
        <template slot="payed" slot-scope="data">
          <div v-if="data.item.payed">
            <b-badge variant="success">Доставлено</b-badge>
          </div>
          <div v-else>
            <b-badge variant="danger">Не доставлено</b-badge>
          </div>
        </template>
        <template slot="action" slot-scope="data">
          <b-button
            :disabled="isDisabled()"
            size="sm"
            @click.stop="info(data.item)"
            class="mr-1 tableActionbtn"
          >
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination
          @input="getBids()"
          :total-rows="dataCount"
          :per-page="paginationOptions.limit"
          v-model="paginationOptions.page"
          prev-text="Предыдущая"
          next-text="Следующая"
          hide-goto-end-buttons
        />
      </nav>
    </b-card>

    <b-modal
      id="addingModal"
      @hide="resetModal"
      title="Добавление заявки"
      centered
      @ok="adding"
      ok-only
    >
      <b-container fluid>
        <b-form-group>
          <label>Контрагент *</label>
          <Multiselect
            name="contrAgent"
            placeholder="Выберите"
            v-validate="'required'"
            v-model="addedBid.contrAgent"
            :options="clients"
            track-by="_id"
            label="fullname"
          ></Multiselect>
          <span
            v-show="errors.has('contrAgent')"
            class="text-danger"
          >{{ errors.first('contrAgent') }}</span>
        </b-form-group>
        <div v-for="(n, index) in forms">
          <div style>
            <b-form-group>
              <label>Передал *</label>
              <Multiselect
                name="provider"
                placeholder="Выберите"
                v-validate="'required'"
                v-model="addedBid.provider[index].id"
                :options="employees"
                track-by="id"
                label="fullname"
              ></Multiselect>
              <span
                v-show="errors.has('provider')"
                class="text-danger"
              >{{ errors.first('provider') }}</span>
            </b-form-group>

             <b-form-group>
          <label>Город</label>
          <b-form-select type="text" name="city" placeholder="Город" v-model="addedBid.city" :options="cities" v-validate="'required'"></b-form-select>
          <span v-show="errors.has('city')" class="text-danger">{{ errors.first('city') }}</span>
        </b-form-group>

            <b-form-group>
              <label>Кол-во мест *</label>
              <b-form-input
                class="modalInput"
                name="placeAmount"
                type="text"
                placeholder="Кол-во мест"
                v-model="addedBid.provider[index].placeAmount"
                v-validate="'required'"
              ></b-form-input>
              <span
                v-show="errors.has('placeAmount')"
                class="text-danger"
              >{{ errors.first('placeAmount') }}</span>
            </b-form-group>
            <b-form-group>
              <label>Сумма</label>
              <b-form-input
                class="modalInput"
                placeholder="Сумма"
                v-model="addedBid.provider[index].summ"
              ></b-form-input>
            </b-form-group>
            <b-form-group>
              <label>Дата *</label>
              <datepicker
                :language="ru"
                v-model="addedBid.provider[index].date"
                name="date"
                v-validate="'required'"
              ></datepicker>
              <span v-show="errors.has('date')" class="text-danger">{{ errors.first('date') }}</span>
            </b-form-group>
          </div>
        </div>
        <b-button size="sm" @click="addForm()">
          <i class="icon-plus"></i>
        </b-button>
        <b-button size="sm" @click="removeForm()">
          <i class="icon-minus"></i>
        </b-button>
        <b-form-group>
          <label>Скидка, %</label>
          <b-form-input type="number" v-model="addedBid.discount"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Дата *</label>
          <datepicker :language="ru" v-model="addedBid.date" name="date" v-validate="'required'"></datepicker>
          <span v-show="errors.has('date')" class="text-danger">{{ errors.first('date') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Объем, м3</label>
          <b-form-input
            @blur="changeValue"
            class="modalInput"
            name="addedBid.volume"
            placeholder="Объем, м3"
            v-model="addedBid.volume"
          ></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Вес, кг</label>
          <b-form-input
            class="modalInput"
            name="addedBid.weight"
            placeholder="вес, кг"
            v-model="addedBid.weight"
          ></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Способ оплаты</label>
          <b-form-select
            v-model="addedBid.payStatus"
            :options="payStatuses"
            class="col-10"
            size="sm"
          />
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100"></div>
    </b-modal>

    <b-modal
      id="modalInfo"
      @hide="resetModal"
      title="Редактирование заявки"
      centered
      @ok="edit"
      ok-only
    >
      <h6>Сотрудник: {{modalInfo.name}} {{modalInfo.lastName}}</h6>
      <b-container fluid>
        <b-form-group>
          <label>Контрагент *</label>
          <!-- <b-form-select v-model="modalInfo.contrAgent._id" :options="clients" class="col-10" size="sm"/> -->
          <Multiselect
            name="contrAgent2"
            placeholder="Выберите"
            v-validate="'required'"
            v-model="modalInfo.contrAgent"
            :options="clients"
            track-by="_id"
            label="fullname"
          ></Multiselect>
          <span
            v-show="errors.has('contrAgent2')"
            class="text-danger"
          >{{ errors.first('contrAgent2') }}</span>
        </b-form-group>
        <div v-for="(n, index) in modalInfo.provider">
          <b-form-group>
            <label>Передал *</label>
            <!-- <b-form-select :options="employees" v-model="modalInfo.provider[index].id" class="" size="sm"></b-form-select> -->
            <Multiselect
              name="provider2"
              placeholder="Выберите"
              v-validate="'required'"
              v-model="modalInfo.provider[index].id"
              :options="employees"
              track-by="id"
              label="fullname"
            ></Multiselect>
            <span
              v-show="errors.has('provider2')"
              class="text-danger"
            >{{ errors.first('provider2') }}</span>
          </b-form-group>
          <b-form-group>
            <label>Кол-во мест *</label>
            <b-form-input
              class="modalInput"
              type="text"
              name="placeAmount2"
              placeholder="Кол-во мест"
              v-model="modalInfo.provider[index].placeAmount"
              v-validate="'required'"
            ></b-form-input>
            <span
              v-show="errors.has('placeAmount2')"
              class="text-danger"
            >{{ errors.first('placeAmount2') }}</span>
          </b-form-group>
          <b-form-group>
            <label>Сумма</label>
            <b-form-input
              class="modalInput"
              placeholder="Сумма"
              v-model="modalInfo.provider[index].summ"
            ></b-form-input>
          </b-form-group>
          <b-form-group>
            <label>Дата *</label>
            <datepicker
              :language="ru"
              v-model="modalInfo.provider[index].date"
              name="date2"
              v-validate="'required'"
            ></datepicker>
            <span v-show="errors.has('date2')" class="text-danger">{{ errors.first('date2') }}</span>
            <!-- <b-form-input class="modalInput"placeholder="Номер" v-model="addedBid.provider[index].date"></b-form-input> -->
          </b-form-group>
          <hr>
        </div>
        <b-button size="sm" @click="addFormEdit()">
          <i class="icon-plus"></i>
        </b-button>
        <b-button size="sm" @click="removeFormEdit()">
          <i class="icon-minus"></i>
        </b-button>
        <b-form-group>
          <label>Скидка, %</label>
          <b-form-input type="number" mask="11" v-model="modalInfo.discount" class size="sm"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Дата *</label>
          <datepicker :language="ru" v-model="modalInfo.date" name="date2" v-validate="'required'"></datepicker>
          <span v-show="errors.has('date2')" class="text-danger">{{ errors.first('date2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Объем, м3</label>
          <b-form-input
            class="modalInput"
            name="modalInfo.volume"
            placeholder="Объем, м3"
            v-model="modalInfo.volume"
          ></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Вес, кг</label>
          <b-form-input
            class="modalInput"
            name="modalInfo.weight"
            placeholder="Вес, кг"
            v-model="modalInfo.weight"
          ></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Способ оплаты</label>
          <b-form-select
            v-model="modalInfo.payStatus"
            :options="payStatuses"
            class="col-10"
            size="sm"
          />
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="edit">Изменить</b-btn>
        <!-- <b-btn class="mt-3" variant="outline-danger" block @click="deleting(modalInfo._id)">Удалить</b-btn> -->
      </b-container>
      <div slot="modal-footer" class="w-100"></div>
    </b-modal>

    <b-modal id="modalEnded" title="Уведомление" centered>
      <b-container fluid>
        <b-form-group>
          <label>Нельзя редактировать, так как завершен</label>
        </b-form-group>
      </b-container>
      <div slot="modal-footer" class="w-100"></div>
    </b-modal>
  </b-container>
</template>

<script>
import { ru } from "vuejs-datepicker/dist/locale";
import Api from "@/services/Api";
import Datepicker from "vuejs-datepicker";
import MaskedInput from "vue-masked-input";
import Multiselect from "vue-multiselect";

export default {
  name: "Bids",
  components: {
    Datepicker,
    MaskedInput,
    Multiselect
  },
  props: {
    caption: {
      type: String,
      default: "Заказы"
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      userLevel: localStorage.getItem("level"),
      // groups: [],
      ru: ru,
      forms: 1,
      items: [],
      constItems: [],
      employees: [],
      clients: [],
      cities: [],
      payStatuses: [
        { value: "cash", text: "Наличными" },
        { value: "online", text: "Онлайн" },
        { value: "payed", text: "Оплачено" }
      ],
      fields: [
        { key: "number", sortable: true, label: "Номер" },
        {
          key: "provider",
          sortable: true,
          label: "Передал (имя, кол-во мест, сумма)"
        },
        { key: "date", sortable: true, label: "Дата и время" },
        { key: "contrAgent", sortable: true, label: "Контрагент" },
        { key: "city", sortable: true, label: "Город" },
        { key: "discount", sortable: true, label: "Скидка" },
        { key: "placeAmount", sortable: true, label: "Кол-во мест" },
        { key: "payStatus", sortable: true, label: "Способ оплаты" },
        { key: "volume", sortable: true, label: "Объем, м3" },
        { key: "weight", sortable: true, label: "Вес, кг" },
        { key: "summ", sortable: true, label: "Сумма" },
        { key: "status", sortable: true, label: "Статус" },
        { key: "payed", sortable: true, label: "Статус" },
        { key: "action", label: "Действия" }
      ],
      currentPage: 1,
      totalRows: 0,
      filter: null,
      employees: [],
      contrAgents: [],
      addedBid: {
        provider: [{ id: "", placeAmount: "", summ: "", date: new Date() }],
        date: new Date(),
        // number: '',
        contrAgent: "",
        discount: "",
        volume: "",
        weight: "",
        payStatus: "",
        city: "",
      },
      modalInfo: {
        _id: "",
        provider: [{ id: [], placeAmount: "", summ: "", date: "" }],
        date: "",
        contrAgent: "",
        discount: "",
        volume: "",
        weight: "",
        payStatus: ""
      },
      types: [
        { value: "number", text: "Номер" },
        { value: "provider", text: "Передал" },
        { value: "contrAgent", text: "Контрагент" },
        { value: "city", text: "Город" }
      ],
      selected: {
        startDate: "",
        endDate: "",
        text: "",
        type: ""
      },
      paginationOptions: {
        page: 1,
        limit: 50,
        dateFrom: "",
        dateTo: ""
      },
      dataCount: 0
    };
  },
  computed: {
    disabled() {
      if (
        this.addedBid.provider[0].id &&
        this.addedBid.provider[0].placeAmount &&
        this.addedBid.provider[0].date &&
        this.addedBid.contrAgent
      ) {
        return false;
      } else {
        return true;
      }
    },

    disabledEdit() {
      if (
        this.modalInfo.provider[0].id &&
        this.modalInfo.provider[0].placeAmount &&
        this.modalInfo.provider[0].date &&
        this.modalInfo.contrAgent
      ) {
        return false;
      } else {
        return true;
      }
    }
  },
  beforeMount() {
    this.getBids();
    this.getEmployees();
    this.getClients();
    this.getCities();
  },
  methods: {
    changeValue() {
      let b = this.addedBid.volume.toString().replace(/\./g, ",");
      this.addedBid.volume = b;
    },
    isDisabled() {
      return this.userLevel === "2" || this.userLevel === "1";
    },
    sort_date(a, b) {
      return new Date(a.date).getTime() - new Date(b.date).getTime();
    },
    filterByDate() {
      this.items = this.constItems;
      let startDate = this.selected.startDate;
      let endDate = this.selected.endDate;
      if (startDate && endDate) {
        startDate.setHours(0, 0, 0, 0);
        endDate.setHours(0, 0, 0, 0);
        this.items.sort(this.sort_date);

        this.items = this.items.filter(function(item) {
          var date = new Date(item.date);
          date.setHours(0, 0, 0, 0);
          if (date >= startDate && date <= endDate) {
            return item;
          }
        });
      }
    },
    discountValue(discount) {
      if (discount < 0) {
        discount = Math.abs(discount);
      }
      if (discount > 100) {
        discount = discount.slice(0, 2);
      }
      return discount;
    },
    addForm() {
      this.addedBid.provider.push({
        id: "",
        placeAmount: "",
        summ: "",
        date: ""
      });
      this.forms++;
    },
    removeForm() {
      if (this.forms > 1) {
        this.addedBid.provider.pop();
        this.forms--;
      }
    },
    addFormEdit() {
      this.modalInfo.provider.push({
        id: "",
        placeAmount: "",
        summ: "",
        date: ""
      });
    },
    removeFormEdit() {
      if (this.modalInfo.provider.length > 1) {
        const answer = confirm("Вы уверены что хотите убрать представителя?");
        if (answer) {
          this.modalInfo.provider.pop();
        } else {
          this.resetModal();
        }
      }
    },
    addProvider(group) {
      this.groups.push(group);
      this.addedBid.provider.push({
        id: "",
        placeAmount: "",
        summ: "",
        date: ""
      });
    },
    getBids() {
      if (!this.selected.text) {
        this.paginationOptions.dateFrom =
          new Date(this.paginationOptions.dateFrom).getTime() || "";
        this.paginationOptions.dateTo =
          new Date(this.paginationOptions.dateTo).getTime() || "";
        Api()
          .get(`getbids${this.QS(this.paginationOptions)}`)
          .then(response => {
            this.items = response.data.docs;
            this.dataCount = response.data.total;
            this.constItems = response.data.docs;
            //this.items.sort(this.sort_date)
          });
      } else {
        Api()
          .post(`searchbid${this.QS(this.paginationOptions)}`, {
            property: this.selected.type,
            text: this.selected.text
          })
          .then(response => {
            console.log(response);

            this.items = response.data.docs;
            this.dataCount = response.data.total;
            this.constItems = response.data.docs;
            // this.items.sort(this.sort_date)
          });
      }
    },
    getEmployees() {
      Api()
        .post("getByParameters", { type: "provider" })
        .then(response => {
          this.employees = response.data.map(item => {
            return { id: item._id, fullname: item.lastName + " " + item.name };
          });
        });
    },
    getClients() {
      Api()
        .post("getByParameters", { type: "client" })
        .then(response => {
          this.clients = response.data.map(item => {
            return { _id: item._id, fullname: item.lastName + " " + item.name };
          });
        });
    },
    getCities () {
      Api().get('getCities').then(response => {
        this.cities = response.data.map(item => {
          return {
            value: item.name,
            text: item.name
          }
        })
      })
    },
    adding() {
      this.$validator.validateAll();
      if (this.validateAdding()) {
        this.addedBid.discount = this.discountValue(this.addedBid.discount);
        this.addedBid.contrAgent = this.addedBid.contrAgent._id;

        for (let i = 0; i < this.addedBid.provider.length; i++) {
          this.addedBid.provider[i].id = this.addedBid.provider[i].id.id;
        }

        Api()
          .post("addbid", this.addedBid)
          .then(response => {
            this.resetModal();
            window.location.reload();
          });
      }
    },
    edit() {
      this.$validator.validateAll();
      if (this.validateEditing()) {
        this.modalInfo.discount = this.discountValue(this.modalInfo.discount);
        for (let i = 0; i < this.modalInfo.provider.length; i++) {
          this.modalInfo.provider[i].id = this.modalInfo.provider[i].id.id;
        }

        Api()
          .post("editbid", this.modalInfo)
          .then(response => {
            this.resetModal();
            window.location.reload();
          });
      }
    },
    deleting(_id) {
      const answer = confirm(
        "Нажмите OK для продолжения или Cancel для выхода."
      );
      if (answer) {
        Api()
          .post("deletingbid", { _id })
          .then(response => {
            if (response.data.n && response.data.n > 0) {
              this.resetModal();
              window.location.reload();
            } else {
              alert("ne udalilsya");
            }
          });
      } else {
        this.resetModal();
      }
    },
    validateAdding() {
      var countIfFilled = 0;
      var countProviders = this.addedBid.provider.length;
      for (var i = 0; i < countProviders; i++) {
        if (
          this.addedBid.provider[i].id &&
          this.addedBid.provider[i].placeAmount &&
          this.addedBid.provider[i].date
        ) {
          countIfFilled++;
        }
      }
      if (
        countIfFilled == countProviders &&
        this.addedBid.contrAgent &&
        this.addedBid.date
      ) {
        return true;
      } else {
        return false;
      }
    },
    validateEditing() {
      var countIfFilled = 0;
      var countProviders = this.modalInfo.provider.length;
      for (var i = 0; i < countProviders; i++) {
        if (
          this.modalInfo.provider[i].id &&
          this.modalInfo.provider[i].placeAmount &&
          this.modalInfo.provider[i].date
        ) {
          countIfFilled++;
        }
      }
      if (
        countIfFilled == countProviders &&
        this.modalInfo.contrAgent &&
        this.modalInfo.date
      ) {
        return true;
      } else {
        return false;
      }
    },
    info(_item) {
      const item = _item.provider;
      this.modalInfo = _item;
      this.modalInfo.contrAgent.fullname =
        _item.contrAgent.lastName + " " + _item.contrAgent.name;
      for (let i = 0; i < item.length; i++) {
        if (item[i].id != null) {
          let name = item[i].id.name;
          let lastName = item[i].id.lastName;
          this.modalInfo.provider[i].id.id = item[i].id._id;
          this.modalInfo.provider[i].id.fullname = lastName + " " + name;
          this.modalInfo.provider[i].name = name;
          this.modalInfo.provider[i].lastName = lastName;
        } else {
          this.modalInfo.provider[i] = {
            name: "",
            lastName: "",
            id: { id: "", fullname: "" }
          };
        }
      }
      if (_item.status === "end") {
        this.$root.$emit("bv::show::modal", "modalEnded");
      } else {
        this.$root.$emit("bv::show::modal", "modalInfo");
      }
    },
    dateFormat(_date) {
      function fmt(n) {
        return n > 9 ? n : "0" + n;
      }
      const now = new Date(_date.toString().trim());
      let time = "";
      if (now != "Invalid Date") {
        _date =
          fmt(now.getDate()) +
          "." +
          fmt(now.getMonth() + 1) +
          "." +
          fmt(now.getFullYear());
        time = fmt(now.getHours()) + ":" + fmt(now.getMinutes());
      }

      return _date + " " + time;
    },
    filterCustom() {
      let text = this.selected.text;
      let type = this.selected.type;
      this.items = this.constItems;
      this.items = this.items.filter(function(item) {
        let reg = new RegExp(text, "i");
        if (
          (type == "number" && reg.test(item.number)) ||
          reg.test(item.number.padStart(5, "0"))
        ) {
          return item;
        } else if (type == "contrAgent" && item.contrAgent) {
          let name = item.contrAgent.name;
          let lastName = item.contrAgent.lastName;
          if (reg.test(name) || reg.test(lastName)) {
            return item;
          }
        } else if (type == "provider" && item.provider[0].id) {
          var isExists = false;
          for (var i = 0; i < item.provider.length; i++) {
            let name = item.provider[i].id.name;
            let lastName = item.provider[i].id.lastName;
            if (reg.test(name) || reg.test(lastName)) {
              isExists = true;
            }
          }
          if (isExists) {
            return item;
          }
        } else if (type == "city" && reg.test(item.contrAgent.city)) {
          return item;
        }
      });
    },
    getRowCount(items) {
      return items.length;
    },
    resetModal() {
      this.addedBid.employee = "";
      this.addedBid.contrAgent = "";
      this.addedBid.placeAmount = "";
      this.addedBid.volume = "";
      this.addedBid.weight = "";
      this.addedBid.summ = "";
      this.addedBid.provider = [
        { id: "", placeAmount: "", summ: "", date: "" }
      ];
      this.forms = 1;
      this.getBids();
      this.errors.clear();
    },
    openAddingModal() {
      this.$root.$emit("bv::show::modal", "addingModal");
    },
    QS(json) {
      return (
        "?" +
        Object.keys(json)
          .map(
            key => encodeURIComponent(key) + "=" + encodeURIComponent(json[key])
          )
          .join("&")
      );
    }
  }
};
</script>
